/*
 * skeltal.c: comms between keybadge and mainbadge
 */

#include "em_device.h"
#include "em_chip.h"
#include "em_leuart.h"

#include "skeltal.h"

/* user functions */
void keyuart_init()
{
	LEUART_FreezeEnable(KEY_UART, 1);

	// set up interrupt on RX
	LEUART_IntEnable(KEY_UART, LEUART_IEN_RXDATAV);
	NVIC_EnableIRQ(KEY_UART_IRQn);

	LEUART_FreezeEnable(KEY_UART, 0);
}

int keyuart_puts(char *c, int cnt)
{
	return 0;
}

int keyuart_gets(char *c, int cnt)
{
	return 0;
}

/* irq handler */
void LEUART0_IRQHandler()
{
	uint32_t flags;

	// clear interrupt flags
	flags = LEUART_IntGet(LEUART0);
	LEUART_IntClear(LEUART0, flags);

	// loopback
	if (flags & LEUART_IF_RXDATAV) {
		LEUART_Tx(LEUART0, LEUART_Rx(LEUART0) + 1);
	}
}
