/*
 * ledprog/skull.c
 */


#include "../led.h"


// program variables
static uint16_t wait_set;
static uint16_t wait;

static uint32_t init;
static uint32_t optn[2];

static uint16_t state;
static uint32_t work[4];


// program listing
static void (*run)(uint16_t *);
static LEDProg prog[LED_PROG_COUNT];

const LEDProg *prog_skull = prog;


// program flow
void skull_prog_run(uint8_t idx, uint16_t iter_wait, uint16_t init, uint32_t optn1, uint32_t optn2)
{

}

void skull_prog_reset(uint8_t clean)
{
	int i;

	wait_set = 0;
	state = 0xffff;

	optn[0] = 0;
	optn[1] = 0;

	if (!clean) return;

	for (i = 0; i < 4; i++) {
		work[i] = 0;
	}
}

// programs
/********
 * around the skull in a loop program
 *********/
#define L_DECPCT 	((optn[0] & 0x000000ff))
#define L_DECRATE 	((optn[0] & 0x0000ff00) >> 8)
#define L_OFFSET 	((optn[0] & 0x00070000) >> 16)
#define L_REVERSE 	((optn[0] & 0x00080000))
#define L_BRITPCT 	((optn[0] & 0xff000000) >> 24)
static void skull_loops(uint16_t *skull)
{
	int i;
	int r;

	// decay
	if (L_DECRATE) {
		if (!work[0]) {
			work[0] = L_DECRATE;

			r = (L_DECPCT * L_BRITPCT);

			for (i = 0; i < 8; i++) {
				if (i != state) {
					if (skull[i] > r) {
						skull[i] -= r;
					} else {
						skull[i] = 0;
					}
				}
			}
		}

		work[0]--;
	}


	// looper
	if (!wait) {
		if (init) {
			state = init & 8;
			init = 0;
		}

		// load new timer wait value
		wait = wait_set;

		// set next LED
		state += L_REVERSE ? 7 : 1;
		state %= 8;

		// set LED PWM levels
		skull[state] = 100 * L_BRITPCT;
	}

	wait--;
}
#undef L_DECPCT
#undef L_DECRATE
#undef L_OFFSET
#undef L_REVERSE
#undef L_BRITPCT



/********
 * random on, random off
 * speed: 	set as desired
 * options: bit 7 = fade off instead of turning off, bit 6 = fade faster
 *          bit 5 = fade even faster, bit 4 = fade faster still
 *          bit 1 = enable purple, bit 0 = enable white
 *********/
/*static void led_prog_rand_on_rand_off()
{
	int i;
	uint8_t fade;

	if (!led_prog_wait) {
		// load new timer wait value
		led_prog_wait = led_prog_set_wait * 5;

		// is this a new run?
		if (!led_prog_state[3]) {
			led_prog_state[3] = 1;

			for (i = 0; i < 16; i++) {
				led_level[LED_MATRIX_WHITE][i] = 0;
				led_level[LED_MATRIX_PURPLE][i] = 0;
			}
		}

		led_prog_state[0] = led_prog_state[0] ? 0 : 1;

		fade = 0;
		if (led_prog_set_option & 0x80) fade = 2;
		if (led_prog_set_option & 0x40) fade += 6;
		if (led_prog_set_option & 0x20) fade += 12;
		if (led_prog_set_option & 0x10) fade += 24;

		for (i = 0; i < 16; i++) {
			if (fade) {
				if (led_level[LED_MATRIX_WHITE][i] > fade) {
					led_level[LED_MATRIX_WHITE][i] -= fade;
				} else {
					led_level[LED_MATRIX_WHITE][i] = 0;
				}

				if (led_level[LED_MATRIX_PURPLE][i] > fade) {
					led_level[LED_MATRIX_PURPLE][i] -= fade;
				} else {
					led_level[LED_MATRIX_PURPLE][i] = 0;
				}
			} else {
				led_level[LED_MATRIX_WHITE][i] = 0;
				led_level[LED_MATRIX_PURPLE][i] = 0;
			}
		}

		if (led_prog_set_option & (1 << led_prog_state[0])) {
			led_level[led_prog_state[0]][pirate_prng() % 16] = led_prog_set_level >> (led_prog_state[0] << 3);
		}
	}

	led_prog_wait--;
}*/
