/**
 * leuart.c
 */

#include "em_device.h"
#include "em_chip.h"
#include "em_cmu.h"
#include "em_leuart.h"

#include "InitDevice.h"


void leuart_init()
{
	// start peripheral clock, configure peripheral
	CMU_ClockEnable(cmuClock_LEUART0, true);
	LEUART0_enter_DefaultMode_from_RESET();

	// configure pins
	/* Pin PC14 is configured to Push-pull */
	GPIO->P[2].MODEH = (GPIO->P[2].MODEH & ~_GPIO_P_MODEH_MODE14_MASK)
			| GPIO_P_MODEH_MODE14_PUSHPULL;
	/* Pin PC15 is configured to Input enabled */
	GPIO->P[2].MODEH = (GPIO->P[2].MODEH & ~_GPIO_P_MODEH_MODE15_MASK)
			| GPIO_P_MODEH_MODE15_INPUT;

	// route pins
	LEUART0->ROUTE = LEUART_ROUTE_RXPEN | LEUART_ROUTE_TXPEN | LEUART_ROUTE_LOCATION_LOC5;
	// and turn on
	LEUART_Enable(LEUART0, true);
}

void leuart_stop()
{
	// deconfigure leuart pins
	LEUART0->ROUTE &= ~(LEUART_ROUTE_RXPEN | LEUART_ROUTE_TXPEN);

	// disable leuart
	CMU_ClockEnable(cmuClock_LEUART0, true);
	LEUART_Enable(LEUART0, false);;

	// stop peripheral cloc if it is startedk
	CMU_ClockEnable(cmuClock_LEUART0, false);
}
