/**
 * lightsens.h
 */

#ifndef __WP2016_HW_LSENS_H
#define __WP2016_HW_LSENS_H


#include "em_gpio.h"


/* struct */
typedef enum {
	LSENS_DARK,
	LSENS_LOW,
	LSENS_NORM,
	LSENS_HIGH,
	LSENS_BRIGHT
} LightSens_Level;


/* constants */
#include "InitDevice.h" 		// pin constants

#define LSENS_K_MODE_MASK 		_GPIO_P_MODEL_MODE4_MASK
#define LSENS_K_MODE_INPUT		GPIO_P_MODEL_MODE4_INPUT
#define LSENS_K_MODE_PP 		GPIO_P_MODEL_MODE4_PUSHPULL

#define LSENS_A_MODE_MASK 		_GPIO_P_MODEL_MODE7_MASK
#define LSENS_A_MODE_PP 		GPIO_P_MODEL_MODE7_PUSHPULL

#define LSENS_STATE_WAIT 		0x03
#define LSENS_STATE_START_ADC 	0xfc
#define LSENS_STATE_ACQUIRE 	0xfd
#define LSENS_STATE_DONE 		0xfd
#define LSENS_STATE_START 		0xfe
#define LSENS_STATE_IDLE 		0xff

#define LSENS_HYSTERESIS 		50

#define LSENS_GAIN_HIGH 		0x7ff
#define LSENS_GAIN_LOW 			0x2ff

#define LSENS_COUNT_MAX 		63


/* variables */
extern uint16_t lsens_count;
extern uint8_t  lsens_gain;


/* light reference table */
extern const uint8_t lsens_ref[];


/* prototypes */
void lsens_led_output(uint8_t out);
void lsens_led_config(GPIO_Mode_TypeDef mode, uint8_t out);

void lsens_adc_input();

void lsens_run(uint8_t start);


#endif
