/**
 * userio.h
 */

#ifndef __WP2016_HW_USERIO_H
#define __WP2016_HW_USERIO_H


/* struct */
typedef struct {
	uint8_t state;
	uint8_t option;
	uint16_t debounce;
	uint16_t hold_cycles;
	void (*cb_push)();
	void (*cb_hold)(uint8_t repeat);
	void (*cb_release)();
} BtnState;


/* hw def */
#define UIN_TOG_SLEEP 			0
#define UIN_TOG_SLEEP_PORT 		5
#define UIN_TOG_SLEEP_PIN 		2

#define UIN_TOG_MODE 			1
#define UIN_TOG_MODE_PORT 		3
#define UIN_TOG_MODE_PIN 		5

#define UIN_BTN_ANY 			7
#define UIN_BTN_ANY_PORT 		2
#define UIN_BTN_ANY_PIN 		9


/* buttons */
#define UIN_DEBOUNCE_CYCLES 	4
#define UIN_HOLD_CYCLES 		800

#define UIN_RELEASE 			0x01
#define UIN_PUSH 				0x02
#define UIN_HOLD 				0x04
#define UIN_HOLD_REPEAT 		0x08
#define UIN_PUSH_MASK 			0x0f

#define UIN_OPT_HOLD_REPEAT 	0x80

#define UIN_CB_PUSH 			0
#define UIN_CB_HOLD 			1
#define UIN_CB_RELEASE 			2


/* prototypes */
void userio_init();
void userio_cb(uint8_t swidx);

uint8_t userio_update(uint8_t alternate);

void userio_sleep_enter();


#endif
