/**
 * rtc/time.h
 */

#ifndef __WP2016_RTC_ALARM_H
#define __WP2016_RTC_ALARM_H


#include <stdint.h>


/* struct */
typedef struct {
	uint16_t modeflags;
	uint16_t actflags;
	char     name[24];
	uint8_t  day;
	uint8_t  month;
	uint8_t  hour;
	uint8_t  minute;
} RTCAlarm; 								// 32 bytes


/* constants */
#define RTC_ALARM_COUNT 			16 		// uses 512bytes RAM

#define RTC_ALARM_MODE_CREATED 		0x8000

#define RTC_ALARM_MODE_MASK 		0x7fff
#define RTC_ALARM_MODE_ENABLE 		0x0001
#define RTC_ALARM_MODE_ONESHOT 		0x0002
#define RTC_ALARM_MODE_REPEAT 		0x0004
#define RTC_ALARM_MODE_AUTODELETE 	0x0008

#define RTC_ALARM_ACT_VIBRATE_MASK 	0x000f 	// vibrator select
#define RTC_ALARM_ACT_LIGHTSPD_MASK 0x00f0 	// light flashing speed select
#define RTC_ALARM_ACT_LIGHT_RED 	0x0100
#define RTC_ALARM_ACT_LIGHT_ALL 	0x0200


/* prototypes */
RTCAlarm * alarm_getptr(int idx);

void alarm_delete(int idx);
void alarm_enable(int idx, uint8_t enable);

uint8_t alarm_check();

char * alarm_get_modetext(int idx);

uint8_t alarm_save_nv();
uint8_t alarm_restore_nv();


#endif
